using System.Security.Claims;
using e_suite.API.Common;
using e_suite.UnitTestCore;
using eSuite.API.Controllers;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Moq;

namespace eSuite.API.UnitTests.Controllers.MailTemplatesControllerUnitTests;

public abstract class MailTemplatesControllerTestBase : TestBase
{
    protected Mock<IMailTemplateManager> _mailTemplateManagerMock = null!;
    protected MailTemplatesController _mailTemplatesController = null!;

    public override async Task Setup()
    {
        await base.Setup();
        _mailTemplateManagerMock = new Mock<IMailTemplateManager>();
        _mailTemplatesController = new MailTemplatesController(_mailTemplateManagerMock.Object);

        const long id = -1;
        const string email = "email@mail.test";
        const string displayName = "Testy McTester";

        AddAuthorisedUserToController(id, email, displayName);
    }

    protected void AddAuthorisedUserToController(long id, string email, string displayName)
    {
        var user = new ClaimsPrincipal(new ClaimsIdentity(
        [
            new(ClaimTypes.PrimarySid, id.ToString()),
            new(ClaimTypes.Email, email),
            new(ClaimTypes.Name, displayName)
            // other required and custom claims
        ], "TestAuthentication"));

        _mailTemplatesController.ControllerContext = new ControllerContext
        {
            HttpContext = new DefaultHttpContext { User = user }
        };
    }
}